;		SCROLLING 1


; Principe :
; On affiche le texte par la droite et on decale la partie ecran 
; vers la gauche de 1 octet pour creer le mouvement
; 
; Pour avoir une fonte graphique ( je suis une quiche en graphisme)
; Je me suis servis d'OCP via le mode TEXTE avec 16 comme hauteur de caractere
; et je les ais tous afficher dans leur ordre de code ASCII.
; le fichier sur la disquette c est FNT16.SCR
; la routine 'memfnt' est utilisee pour enregistrer cette fonte en memoire au format utiliser par le scrolling
; a savoir par tranche verticale de 1 octet de large
; Je l utilise sous forme de fichier .asm pour l emulateur ca evite de le charger a chaque fois
;
; Pour avoir les adresses ecran du scrolling je me suis servis de la RLM calculadr
; Pour un scroll de 16 de haut en bas de l ecran faut calcul l adresse de la ligne 200-16
; En chargeant le coin haut gauche de l ecran #C000 dans HL et en faisant 184 call #bc26 
; on arrive a l adresse voulu du coin haut gauche du scrolling
; et en ajoutant 79 on a l adresse du coin haut droite pour l ecriture du message
; 
; et c est parti !!

;
	READ "FNT2.ASM"		; la fonte utiliser

	Org #8000

MAIN	call #bd19		; Synchro video
				; Affichage d une tranche de lettre a gauche
	cAll mouvecr		; Deplace de un octet la zone de scroll prevu
	call tranchetxt		; Affichage d une tranche de lettre a gauche
	xor a
	call #bb1b		; Test touche
	cp #20			; Touche espace
	jr nz,MAIN		; Pas de touche alors on boucle sinon ont passe en dessous
	ret			; Rend la main ;)
;
;	Ces routines sont annexe , c est pour preparer la fonte et calculer l adresse video du scrolling
;
	jp memfnt	; Memorise la fonte dans le format voulu. Ici c est 16 octets de haut sur 4 de large
			; je veux que le scrol soit sur les 16 dernieres lignes du bas de l ecran
	jp calculadr	; calcule l adresse du coin haut gauche du scrol

	; GESTION DU TEXTE DU SCROLL
	;
	; Partie la plus "complexe" du scroll quand on commence
	; Ma fonte fait 4 octet de large
	; Donc je dois afficher une tranche de lettre a chaque mouvement
	; et tout les 4 tranches je doit passer a la lettre suivant
	; Je dois faire un calcul pour faire correspondre une lettre du texte
	; a l adresse de la fonte en memoire
	; mon plus petit caractere (code ascii parlant) c est l espace
	; qui est coder en memoire #20, 32 en decimal
	; donc je vais soustraire cette valeur au caractere que je veux afficher pour trouver sa place dans la fonte
	; avec son numero de place je le multiplie par l espace occuper par une lettre
	; 16 de haut * 4 de large = 64
	; par exemple mon ESPACE - #20 = 0 0*64 = 0 donc ma lettre se situe a fonteadr+0 ;)
	; mon A majuscule = #41 - #20 = #21 #21*64 = #840 soit ma lettre se situe a fonteadr+#840
	; 
	; j ai afficher toute la lettre ?
	; oui je passe a la suivvant ,non je continu l affichage etc
	;
tranchetxt
adrecr	equ #C77F		; Coin haut droit du scroll pour afficher la tranche de lettre
larLet	equ 4			; Largeur de lettre

larg	LD   a,larLet-1		
	INC  a				
	CP   larLet		; Si lettre fini on passe a une autre sinon on continu l affichage			
	jp   z,nextLet		; 
	LD   (larg+1),a		; sauvegarde du compteur de largeur
adrfnt	LD   hl,0000		; adresse fonte en cours
	jp   print1		; on fini la lettre
nextLet
	XOR  a
	LD   (larg+1),a		; reset de la largeur en cours
;
adtxt	LD   hl,TXT		; hl pointe sur lettre a afficher
	LD   a,(hl)
	or a			; lettre =0 ? fin de texte par 0
	jp   nz,suite		; sinon, continue
	LD   hl,TXT		; si oui, remet le texte au debut
	LD   a,(hl)
suite
	INC  hl			; incremente et sauve le pointeur du texte
	LD   (adtxt+1),hl
                                  
	SUB  32 ;  		; calcule de la position de la lettre dans la fonte
				; numero de lettre x 64
	add a 			; x2
	ld l,a
	ld h,0
	add hl,hl		; x4
	add hl,hl		; x8
	add hl,hl		; x16
	add hl,hl		; x32
	add hl,hl		; x64
	ld de,fonte
	add hl,de		; hl=adresse fonte
;
print1
	ld de,adrecr		; adresse d ecriture en memoire video
	ld b,16			; hauteur de la lettre
bcl05	push bc
	push de
	ldi
	pop de
	ex de,hl		; Echange de registre car BC26 calcule l adresse via le registre HL
	call #bc26		; calcule de la ligne du dessous
	ex de,hl
	pop bc
	djnz bcl05		; hop on boucle 16 fois
	ld (adrfnt+1),hl	; Sauvegarde l adresse de fonte en cours
	ret			; et retour ;)

txt	defb "ABCDEFGHIJKLMNOPQRSTUVZXYZ !!! comment allez vous !!! Bonne annee !! 1234567890 !!!    ........        ",0


; 			LE MOUVEMENT DU SCROLL 
; donc on vas decaler un bloc de 16 octet de haut sur 79 de large !!
; largeur de l ecran -1 
; cette rlm deplace le bloc de 1 octet a gauche (et oui apres faut ecrire a droite) !!


adrscrol equ #c730	; Coin haut gauche du scroll
mouvecr
	ld hl,adrscrol	; adresse coin haut gauche de la zone a scroll
	ld b,16		; hauteur du scrol
bcl04	push bc		
	push hl
	ld d,h		; transfere valeur de hl dans de ( de = destination)
	ld e,l	
	inc hl		; inc hl de 1 pour creer le mouvement de 1 octet vers la gauche
	ld bc,79	; largeur du deplacement
	ldir		; LDIR deplace un nombre d octet BC a l adresse de depart HL vers l adresse DE
	pop hl
	call #bc26	; calcule de la ligne du dessous
	pop bc
	djnz bcl04	; et on boucle 16 fois
	ret		; et c est tout ;)
 
; 		LES ADRESSES ECRAN DU SCROL
; besoin de l adresse haut gauche du scroll et droite 
; celle de gauche pour le deplacement et celle de droite pour afficher
; la fonte
; les adresses ecrans etant traitees differement on vas faire une boucle
calculadr
	ld hl,#c000	; adr haut gauche de l ecran
	ld b,200-16	; 200 hauteur max - 16 pour notre scroll
bcl03	push bc
	call #bc26
	pop bc
	djnz bcl03
	ld de,79	; ici hl = coin haut gauche du scrol C730 . Un break ici pour noter l adresse HL
	add hl,de
	ret		; ici hl = coin haut droite du scrol C77F . Un break ici pour noter l adresse HL


;
;                                LA FONTE GRAPHIQUE______________________________________________________
; fonte 16 haut sur 4 de large
; le scroll sera a l octet en mode 1
; il faut preparer la fonte pour son utilisation en "tranche"
; on vas sauvegarder la fonte en trange de 1 octet de large sur 16 de haut
; adr debut #c000 sur 80 oct de large
; 3 ligne de caractere (2 de 20 + 1 de 7)

; enregistre la fonte vers le format voulu
; ensuite marque en data pour desassembler

memfnt
	
fonte 	equ #4000	; la ou sera stocker la fonte
	ld hl,#c000
	ld de,#4000
	ld b,5		; Nombre de ligne de lettre a memoriser
bcl0	push bc
	push hl
	ld b,80		; larg ligne
bcl01	push bc
	push hl
	ld b,16		; Hauteur de lettre
bcl02	push bc
	push hl
	ldi
	pop hl
	call #bc26
	pop bc
	djnz bcl02	; fin d une tranche de 16 de haut sur 1 de large
	pop hl
	inc hl
	pop bc
	djnz bcl01	; fin d une ligne complete
	pop hl
	ld b,16
calc	push bc
	call #bc26
	pop bc
	djnz calc
	pop bc
	djnz bcl0
	ret	
; A la fin de cette RLM  nous avons une fonte en memoire de 91*64oct soit 5824 oct #16c0 en hexa
; En basic ca se sauvegarde par save"fonte.fnt",b,&4000,&16C0

;
