;
;		EXEMPLE SCROLL 4

;	Scrolling hard sur 1a largeur de l ecran
;	Le petit + c est de le faire au pixel 
;	Principe > on deplace l adresse hardware video d'affichange de l ecran via reg 12 et 13 
;		pour le mouvement de droite a gauche
;		Pour ralentire le scroll on vas swap sur 4 ecrans et fontes 
;
;	la fonte fait 12 de large sur 30 de haut (d ailleur la hauteur pour ce genre
;	de scrolling devrait etre un multiple de 8 ;) )
;	Elle provient de la compile de fontes de Prodatron !! merci a lui/eux au passage ;)
; 
;	CRTC R1=49 toute la largeur.  
;	     R2=50 coller a droite 
;	     R6=4  4 lignes de caracter de haut.
;	     R7=20 pour centre en vertical
;	
;	     les 4 fonstes sont trop grandes alors go en banques ;)

	org #9500

fontes	equ #4000		; banque c0 c4 c5 c6

adrecr	equ #C000+#5E		; adresse ecran ou l ecriture de la fonte se fera
adrecr2 equ #c188+#5E 	 	; idem
adrecr3	equ #c310+#5E 		; idem
adrecr4	equ #c498+#5E		; idem

larLet	equ 6	

main				; l ordre a afficher c est c6 c5 c4 c0
	call #bd19		; Synchro video
swa	call HARD1		; l appel de routine qui vas changer a chaque boucle
	xor a			; test touche
	call #bb1b		; test touche
	cp #20			; touche espace
	jr nz,MAIN		; pas de toucher espace presser ? je boucle
	RET
HARD1	
	ld ix,hardadr01		; le pointeur des infos d affichage pour chaque swap
				; cela evite de taper 4 routines differentes , pour l exemple nous sommes large
				; en temp machine
	call affich		; affiche une tranche de lettre
	call crtc		; calcule l adresse hard pour l affichage
	ld hl,hard2		; change le prochain appel pour l ecran suivant
	ld(swa+1),hl
	ret
HARDADR01
	DEFW 0			; Adresse HARD pour l ecran 1
	db larlet-1		; largeur de la lettre en cours
	dw 0000			; adresse fonte en cours
	dw txt			; adresse texte en cours     
	dw adrecr		; adresse ecran ou commence l affichage
	db #c6			; banque ou se trouve la fonte utilise
HARD2	
	ld ix,hardadr02		; et tout ca 4 fois d affiler
	call affich
	call crtc
	ld hl,hard3		
	ld(swa+1),hl
	ret
HARDADR02		
	DEFW #c4
	db larlet-1
	dw 0000
	dw txt
	dw adrecr2
	db #c5
HARD3
	ld ix,hardadr03
	call affich
	call crtc
	ld hl,hard4
	ld(swa+1),hl
	ret
HARDADR03
	DEFW #c4+#c4
	db larlet-1
	dw 0000
	dw txt
	dw adrecr3
	db #c4
HARD4
	ld ix,hardadr04
	call affich
	call crtc
	ld hl,hard1
	ld(swa+1),hl
	ret
HARDADR04
	DEFW #c4+#c4+#c4
	db larlet-1
	dw 0000
	dw txt
	dw adrecr4
	db #c0

crtc	ld h,(ix+1)		; ici on calcule les adresses hardware pour les reg 12 et 13
	ld l,(ix+0)		; comme tous nos ecrans sont sur la meme banque une seule routine suffit
	INC HL
	ld (ix+0),l
	ld (ix+1),h
	LD   A,H		; control de la position du compteur
	AND  #03		; le and et le or permettent de plafonner le compteur
	OR   #30		; qui boucle a #3ff 
	ld bc,#bc0C
	out (c),c
	inc b
	out (c),A		; 
	dec b
	inc c			; 
	out (c),c		;
	inc b
	out (c),l
	ret
affich
	ld b,#7F		; selection de la banque ou est stocke la fonte
	ld c,(ix+9)
	out (c),c
	LD   a,(ix+2)		; la largeur de la lettre en cours (fini ou pas ?)
	INC  a			; la largeur de lettre est diviser par deux ici 6 pour lettre de 12				
	CP   larLet		;
	jp   z,nextLet		; lettre suivante ou on fini l affichage en cours
	LD   (ix+2),a		; 
	ld h,(ix+4)		; adresse fonte en cours
	ld l,(ix+3)
	jp   print1		; on fini la lettre
nextLet
	XOR  a
	LD   (ix+2),a		; reset largeur en cours pour nouvelle lettre	
	ld h,(ix+6)		; hl pointe sur lettre a afficher
	ld l,(ix+5)
	LD   a,(hl)
	or a			; lettre =0 ? fin de texte par 0
	jp   nz,suite		; si non, continue
	LD   hl,TXT		; si oui, remet texte au debut
	LD   a,(hl)
suite
	INC  hl
	ld (ix+6),h
	ld (ix+5),l		; incremente et sauve le pointeur du texte
        cp #20			; est ce un espace ? ( pas d espace specifique dans la fonte ;)
	jp nz,noesp		;
	ld hl,fntesp		; 
	jp print1
noesp	SUB  #41		; calcule de la position de la lettre dans la fonte
				; numero de lettre x360 ( taille d une lettre dans la fonte)
	add a 			; x2 2
	ld l,a
	ld h,0
	add hl,hl		; x4 4
	add hl,hl		; x8 8
	push hl
	add hl,hl		; x16 16
	add hl,hl		; x32 32
	push hl
	add hl,hl		; x64 64
	push hl
	add hl,hl		; x128 128
	add hl,hl		; x256 256
	pop de
	add hl,de		; 256+64 320
	pop de		
	add hl,de		; 320+32 352
	pop de
	add hl,de		; 352+8  360	une lettre occupe 360 octets
	ld de,fontes		; pas besoin de pointeur pour la fonte c est toujours 4000 l adresse
	add hl,de		; hl=adresse de la lettre dans la fonte
;
print1				; ecrit la tranche
				
	ld d,(ix+8)
	ld e,(ix+7)		; DE = adresse ecran a droite ou l on ecrit le debut de lettre
	inc de
	inc de
	ld a,d
	and #c7			; on reste bien sur la premiere ligne du caractere c000 c7ff
	ld (ix+8),a
	ld (ix+7),e
				; sauve la prochaine adresse ;)
	ld b,30			; hauteur de lettre
bcl05	push bc
	push de
	ldi
	ldi
	pop de
	call bc26d		; rlm du bc26 mais pour DE
	pop bc
	djnz bcl05
	ld (ix+4),h		; sauve l adresse de la fonte en cours
	ld (ix+3),l
	ld hl,blanc		; lier au probleme de hauteur de la fonte ;)
	ldi
	ldi
	dec de
	dec de
	call bc26d
	ldi
	ldi
	ret

BC26D	LD   A,D		; bc26 pour reg DE
	ADD  A,#08
	LD   D,A
	AND  #38
	RET  NZ	
	LD   A,D
	SUB  #40
	LD   D,A
	LD   A,E
	ADD  A,98		; largeur ecran en octets (reg R1x2)
	LD   E,A
	RET  NC
	INC  D
	LD   A,D
	AND  #07
	RET  NZ
	LD   A,D
	SUB  #08
	LD   D,A
	RET  
txt	db "SALUT LES GENS   EXEMPLE SCROLL NUMERO QUATRE        ABCDEFGHIJKLMNOPQRSTUVZXYZ      ",0
blanc	defb 0,0,0,0
fntesp defs 360,00