;	Scrol vertical soft
;	de l epoque MB8 Scroll fin
;
;	fonte 8 de haut 1 de large
;	adr ecr c78d
;	
read 	"fonte.asm"
read    "texte.asm" 	; texte du scrolling formater en 50 caractere par ligne
ADRFNT	equ #7d00	; adresse de la fonte 1 octet de large sur 8 de haut
adrecrd equ #c78D	; adresse ecran d ecriture du texte
	
	ORG #8000	; debut programme
	
	call INIT	; formate ecran , couleurs , chargement et ecriture d une partie du code	
Main
	ld a,0		; ont monte l ecran de 8 ligne et puis on affiche une ligne de texte
	inc a
	cp 8		; compteur de ligne (8 et ca boucle)
	jp nz,noaff
	xor a
	ld (textecr),a	; je colle un nop pour authoriser  la routine d affichage de ligne texte 
noaff	ld (main+1),a	; sauvegarde du compteur de ligne
	
	LD B,#F5	; synchro vbl
SYNCHR			;
	IN A,(C)
	RRA
	JR NC,SYNCHR	;
	CALL SCROLL	; appel du scrolling de l ecran d une ligne vers le haut
	CALL TEXTECR	; appel de l ecriture texte qui ne sera effectif que toute les 8 lignes
	LD A,18		; test touche return  pour la pause
	CALL #BB1E	; test clavier
	CALL NZ,Pauses	; Boucle en pause tant que la touche n est pas relache
	LD A,#2F	; test touche espace pour la fin 
	CALL #BB1E	; test clavier
	JP Z,Main	; boucle ou quitte 
	LD BC,#BC06	; retour normale
	LD A,#19	; pour la hauteur ecr visible
	OUT (C),C
	INC B
	OUT (C),A
	ld a,1		; mode 1 et hop salut ;)
	jp #bc0e
	
Pauses
	LD A,18		; numero de la touche a tester , ici Return
	CALL #BB1E
	JP NZ,Pauses
	ret

SCROLL			; routine pour monter l ecran d une ligne 
			; modifier par rapport a l original qui piquait vraiment les yeux ;)
	DI
	LD (spsav+1),sp	; sauvegarde de la pile pour restauration plus tard
	ld sp,tabecr	; les adresses ecrans generer dans la rlm INIT
	ld a,#c7	; hauteur d ecran ;)
bclscrol		;
	pop de		; adresse destination
	pop hl		; adresse source
	dec sp		; recul d une adresse pour le prochain mouvement
	dec sp
ldata	ldi		; 50 LDI pour le transfere d une ligne
	defs 98		; 100 NOP pour les LDI 
	dec a
	or a		; 199 ligne de faite ?
	jr nz,bclscrol	; non ? alors on boucle jusqu a ce que le compteur arrive a 0
spsav	ld sp,#0000	; recupere la pile
	ei 		; relache les interruptions
	ret		; fin !! ;)
textecr
	RET		; swap entre RET et NOP toutes les 8 lignes
	LD A,#c9	; 
	ld (textecr),a
			
	LD B,50		; 50 lettres/octets
aff50			;
	PUSH BC
	CALL AFTRANCH	; affiche une lettre
	LD HL,(adecr+1)	; avance l adresse d ecriture
	INC HL
	LD (adecr+1),hl	
	POP BC
	DJNZ aff50	; boucle 50 fois
	LD HL,adrecrd	; reset adresse ecran pour le prochain appel
	LD (adecr+1),hl	;
	ret		;
AFTRANCH		; ici c est pas une tranche mais la lettre complete vue qu elle fait 1 de large
	LD HL,txt	; Adresse du texte
	LD A,(HL)
	OR A		; fin de texte ?
	JP NZ,AFCONT	; non ? alors on saute en AFCONT
	LD HL,adrecrd	; oui ? reset adresse ecran et adresse texte
	LD (adecr+1),hl
	LD HL,txt
	LD A,(HL)

afcont			; 
	INC HL			; calcule basic de l adresse de la fonte 
	LD (aftranch+1),hl	; deja vu plusieurs fois precedement
	SUB #20			; partie Hautement perfectible ;)
	LD H,#00
	LD L,A
	ADD HL,HL		; x2
	ADD HL,HL		; x4
	ADD HL,HL		; x8  ( une lettre = 8 octets
	LD DE,adrfnt		;
	ADD HL,DE
		
adecr	LD DE,adrecrd		; adresse d affichage du texte
	LD BC,#08FF		; 8 ligne de haut et c est bon ;)
aflet				;
	LDI
	DEC DE
	LD A,D
	ADD #08
	LD D,A
	DJNZ aflet		;
	RET

BC26
	LD A,H
	ADD #08
	LD H,A
	AND #38
	RET NZ
	LD A,H
	SUB #40
	LD H,A
	LD A,L
	ADD #50
	LD L,A
	RET NC
	INC H
	LD A,H
	AND #07
	RET NZ
	LD A,H
	SUB #08
	LD H,A
	RET

	
INIT	
	LD A,#02	; mode ecran et couleurs
	CALL #BC0E
	XOR A
	LD BC,#0000
	CALL #BC32
	LD BC,#0000
	CALL #BC38
	LD A,#01
	LD BC,#1A1A
	CALL #BC32

	ld hl,ldata
	ld de,ldata+2
	ld bc,98
	ldir
	LD B,#c8
	ld ix,TABECR
	LD HL,#c00D
bclINIT	ld (ix+1),h
	ld (ix+0),l
	call BC26
	INC IX
	INC IX
	DJNZ BCLINIT
	LD BC,#BC06	; retour normale
	LD A,#18
	OUT (C),C
	INC B
	OUT (C),A
	RET
TABECR	
	DEFS 400	; 200 ligne ecran en 16b 400 oct