; 	
;
;		SCROLLING EN VAGUE SANS TABLE DEFINIE
;		
;
;		Permet plusieurs vagues et une plus grande taille
;
;
;		Principe :
;
;		Pre calculer un espace dans lequel les vagues vont evoluees
;		si on prend le sinus scroll de l exemple precedent qui tourne sur
;		3 banques pour 48 000 octets , pour rappel le scrol fait 45 de large sur 12 de haut ;)
;		Avec cette methode il faudrait une table de 27*45 octets 1215 octet + les  octets qui
;		vont definir une forme (ou x fois le nombre de vagues) sachant qu une vague peut etre 
;		beaucoup plus longue que la taille de l ecran pour eviter le cote repetitif
;		le point de reference des infos de la courbes serat le coin haut gauche
;		les infos de la courbe ne concerne que la hauteur
;		ont part du principe que l on avance toujours d un octet de la gauche vers la droite
;		si le premier chiffre est 10 alors ont se place a x0 y+10
;		le +10 nous fait decendre dans la table de 10 ligne 
;		plus la valeur est haute et plus le point est bas ;)
;		pensez toujours que le point le plus bas ne peut pas depasser 
;		la hauteur de la table - la hauteur du scroll
;		la table est sauvgarder par tranche de 1 octet de haut en bas
;		
;		l origine de cette version proviens de l etude de l intro de GOZEUR dans MAXI MICRO 8
;	        
;		Pour ce code ont vas faire un scrolling en vagues de la largeur de l ecran et 8 de haut
;		
;
;
;		ma premiere forme vas de 0 a 80 en points de hauteur
;		donc ma table " espace de la vague " 
;		devra faire 80+ 8 (hauteur fonte) + 4 (ligne d effacement) = 92 lignes de haut 
;		sur 80 de large (largeur ecran )
;		92x80 en nb d adresse = 7360 soit 0x1CC0
;		et 7360x2 en espace memoire = 14720 soit 0x3980
;		
;
;		le tampon du scrolling fait 8*80 (#280)
;		mais pour un reset compteur avec un res 3,h je le monte a #400
;		dans notre cas la place memoire est dispo
;		tampon a 3800 , res 2,h reset a 3bff


table	equ #4000		; table d adresse ecran de l espace vague
tamponB	equ #2800		; le texte sera preparer ici
tamponA EQU #3800
haut	equ 8			;  hauteur de la fonte
fonteA	equ #8F00		; adresse de la fonte
fonteB	equ #9780		; adresse de la fonte
larLet	equ 3			; largeur de lettre

	org #8000

;	creation de l espace de la vague
;	table d adresses ecran par colone de 1 octet
	call creatFond
;	
;	Ici bcl pricipale
;	1) on fait avancer le pointeur de la vague
;	2) on affiche le tampon
;	3) on affiche le texte dans le tampon
;	test touche et on boucle
;
Main
	Call #bd19		; ont ne le presente plus ;)

posi	ld de,forme+160
	dec de			; si on decremente de 2,3 ou plus ca
				; accelere le mouvement , attention au traces
	ld a,e			; teste si je depasse pas les 160 points de ma vague
	or a
	jr nz,suiteADR		; si faux saut
	ld (vaguePosition+1),de	; il faut traiter la position 0
	ld e,160		; reset du compteur
	jp suiteADR2
suiteADR
	ld (vaguePosition+1),de	; sauvegarde de la position si pas 0
suiteADR2
	ld (Posi+1),de		; sauvegarde du compteur
swap	call swap2		; alterne les deux fontes pour ralentire le scrolling			

	xor a			; test touche
	call #bb1b		; 
	cp #20			; touche espace
	jr nz,MAIN		; pas de toucher espace presser ? je boucle
	RET
; 	
;
; 
swap1	
	ld hl,(adrtmp1)		; on alterne swap1 et swap2 a chaque appel
	ld (adrtampon+1),hl
	ld hl,adrtmp1
	ld (adrtp2+1),hl
	ld iy,tranchdat1
	call tranchetxt		; affiche une tranche de lettre dans le tampon ;)  
	call affpile		; affiche le tampon
pause3	ld hl,swap2		; le swap de fonte pour l effet "demi-octet"
	ld (swap+1),hl
	ret

adrtmp1	defw tamponA

tranchdat1
	db larlet-1
	dw 0000			; adresse fonte en cours
	dw txt			; adresse txte     
	dw fonteA		; adresse de fonte
	dw tamponA+720		; bien rester hors affichage ecran et divisible par 8

swap2	
	ld hl,(adrtmp2)
	ld (adrtampon+1),hl	
	ld hl,adrtmp2
	ld (adrtp2+1),hl
	ld iy,tranchdat2
	call tranchetxt		; affiche une tranche de lettre dans le tampon ;)  
	call affpile		; affiche le tampon
	ld hl,swap1		; le swap de fonte pour l effet "demi-octet"
	ld (swap+1),hl
	ret
tranchdat2
	db larlet-1
	dw 0000			; adresse fonte
	dw txt			; adresse txte     
	dw fonteB
	dw tamponB+720		; bien rester hors affichage ecran et divisible par 8
;
adrtmp2	defw tamponB
affpile	di			; stop interruption 
	exx			; pour eviter les bug au retour sous basic 
	push hl			; on sauves les registres secondaires
	push de
	push bc
	exx
	ld (savsp+1),sp		; sauve la pile
adrtampon			; gestion de l adresse du tampon , ce qui creer le mouvement
	ld hl,tamponA		; tampon ou vas se faire l ecriture du texte
	ld de,haut		; hauteur de lettre 8
	add hl,de		; ce qui donne le mouvement ( ca avance d une tranche)
	res 2,h			; sert a boucler l adresse ,3800 -- 3BFF a definir suivant le tampon
adrtp2	ld (adrtampon+1),hl	; sauve la nouvelle adresse
	ex af,af'		; le compteur pour la largeur est dans A'
	ld a,80			; nombre de tranches , le compteur
	
;;-------------------------------------

aftabl0
	ex af,af'		; on reserve au chaud
	exx			; registres secondaires------------------------
adrtable
	ld hl,table-184		; les adresses ecran ou la vague vas evoluer
	ld de,184		; tranche suivante (92 lignes de haut x 2 car adresses 16bits
	add hl,de
	ld (adrtable+1),hl	; ca avance d une tranche ;)
vaguePosition
	ld de,forme		; pointe sur les donnees de la forme
	inc de			; test si depassement de la longeure de la forme
	ld a,e			; 
	cp #a0			;
	jp nz,suiteform		; si faux saut
	ld e,0
suiteform
	ld (vaguePosition+1),de	; sauvegarde de la position de la vague
	ld a,(de)	
	sla a			; multiplie par deux pour une adresse 16bits
	ld b,0			
	ld c,a
	xor a
	add hl,bc		; adresse de la hauteur de la tranche
	ld sp,hl		; SP pointe sur la table d adresse a la hauteur defini par la forme
	exx			; retour primaires -------------------------------------------------

	pop de			; deux premiere ligne a 0 pour effacer les traces
	ld (de),a		; cls ;)
	pop de			; cls
	ld (de),a		; cls
	pop de			; et la on affiche
	ldi ;1
	pop de
	ldi ;2
	pop de
	ldi ;3
	pop de
	ldi ;4
	pop de
	ldi ;5
	pop de
	ldi ;6
	pop de
	ldi ;7
	pop de
	ldi ;8
	pop de
	ld (de),a		; traces du bas 
	pop de			; cls
	ld (de),a		; cls
	res 2,h			; reset compteur du tampon
	ex af,af'		; retour de A' pour le compteur
	dec a			; nombre de colonne ?
	or a
	jp nz,aftabl0 		; 
	ex af,af'		; restauration des registres	
	exx
savsp	ld sp,0000		; restauration de la pile
	pop bc			; des registres
	pop de
	pop hl
	exx
	ei
	ld hl,table-184 	; reset de l adresse du fond d ecran ;)
	ld (adrtable+1),hl
	RET			; retour ;)

tranchetxt

;				on affiche une tranche de lettre
;				deja traiter plusieurs fois
	LD   a,(iy)		;		
	INC  a				
	CP   larLet			
	jp   z,nextLet		; lettre suivante ou on fini l affichage en cours
	LD   (iy),a		;
	LD h,(iy+2)
	ld l,(iy+1)	
				; adresse fonte en cours
	jp   print1		; on fini la lettre
nextLet
	XOR  a
	LD   (iy),a		; reset largeur en cours
				; hl pointe sur lettre a afficher
	LD h,(iy+4)
	ld l,(iy+3)	
	LD   a,(hl)
	or a			; lettre =0 ? fin de text par 0
	jp   nz,suite		; si non, continue
	LD   hl,TXT		; si oui, remet texte au debut
	LD   a,(hl)
suite
	INC  hl			; incremente et sauve le pointeur du txt
	ld (iy+3),l
	ld (iy+4),h	                      
	SUB  32  		; calcule de la position de la lettre dans la fonte
				; numero de lettre x 16
	add a 			; x2
	ld l,a
	ld h,0
	add hl,hl		; x4
	add hl,hl		; x8
	push hl
	pop de
	add hl,hl		; x16
	add hl,de
	ld d,(iy+6)		; adresse de la fonte
	ld e,(iy+5)		;
				; ld de,fonte
	add hl,de		; hl=adresse fonte
;
print1
	ld de,tamponA+720	; adr ecriture = ecran+10
	ld d,(iy+8)
	ld e,(iy+7)
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	res 2,d			; reset tampon a 400
			
	ld (iy+1),l		;  sauvegarde des valeurs tampon et adresse fonte
	ld (iy+2),h		;
	ld (iy+7),e		;
	ld (iy+8),d
	ret			; fin


creatFond
				; vide le tampon au cas ou ;)
	ld hl,tamponA
	ld d,h
	ld e,l
	inc de
	xor a
	ld (hl),a
	ld bc,#3Ff
	ldir			; 92 de hauteur en partant du bas
	ld hl,tamponB
	ld d,h
	ld e,l
	inc de
	xor a
	ld (hl),a
	ld bc,#3Ff
	ldir		
	
	ld ix,table		; E410
	ld hl,#e410		; adresse de debut
	ld b,80			; largeur
bcl001  push bc
	push hl
	ld b,92			; hauteur
bcl002	
	ld (ix+1),h
	ld (ix),l
	inc ix
	inc ix
	call #bc26
	djnz bcl002
	pop hl
	inc hl
	pop bc
	djnz bcl001
	ret



	org #8200
forme
	db #28,#29,#2b,#2d,#2e,#30,#31,#33
	db #34,#36,#37,#39,#3a,#3b,#3d,#3e
	db #40,#41,#42,#43,#44,#45,#46,#48
	db #48,#49,#4a,#4b,#4c,#4c,#4d,#4e
	db #4e,#4e,#4f,#4f,#50,#50,#50,#50
	db #50,#50,#50,#50,#50,#4f,#4f,#4e
	db #4e,#4e,#4d,#4c,#4c,#4b,#4a,#49
	db #48,#48,#47,#45,#44,#43,#42,#41
	db #40,#3e,#3d,#3b,#3a,#39,#38,#36
	db #34,#33,#32,#30,#2e,#2d,#2b,#29
	db #28,#27,#25,#23,#22,#20,#1f,#1d
	db #1c,#1a,#19,#17,#16,#15,#13,#12
	db #10,#0f,#0e,#0d,#0c,#0b,#0a,#08
	db #08,#07,#06,#05,#04,#04,#03,#02
	db #02,#02,#01,#01,#00,#00,#00,#00
	db #00,#00,#00,#00,#00,#01,#01,#02
	db #02,#02,#03,#04,#04,#05,#06,#07
	db #08,#08,#09,#0b,#0c,#0d,#0e,#0f
	db #10,#12,#13,#15,#16,#17,#18,#1a
	db #1c,#1d,#1e,#20,#22,#23,#25,#27

txt	defb "ABCDEFGHIJKLMNOPQRSTUVZXYZ !!! comment allez vous !!! sinus scroll !!!! !!"
	defb " 1234567890 !!!    ........        ",0